]> asedeno.scripts.mit.edu Git - linux.git/blob - arch/powerpc/kernel/prom_init_check.sh
Merge tag 'dev_groups_all_drivers' of git://git.kernel.org/pub/scm/linux/kernel/git...
[linux.git] / arch / powerpc / kernel / prom_init_check.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0-or-later
3 #
4 # Copyright © 2008 IBM Corporation
5 #
6
7 # This script checks prom_init.o to see what external symbols it
8 # is using, if it finds symbols not in the whitelist it returns
9 # an error. The point of this is to discourage people from
10 # intentionally or accidentally adding new code to prom_init.c
11 # which has side effects on other parts of the kernel.
12
13 # If you really need to reference something from prom_init.o add
14 # it to the list below:
15
16 grep "^CONFIG_KASAN=y$" .config >/dev/null
17 if [ $? -eq 0 ]
18 then
19         MEM_FUNCS="__memcpy __memset"
20 else
21         MEM_FUNCS="memcpy memset"
22 fi
23
24 WHITELIST="add_reloc_offset __bss_start __bss_stop copy_and_flush
25 _end enter_prom $MEM_FUNCS reloc_offset __secondary_hold
26 __secondary_hold_acknowledge __secondary_hold_spinloop __start
27 logo_linux_clut224 btext_prepare_BAT
28 reloc_got2 kernstart_addr memstart_addr linux_banner _stext
29 __prom_init_toc_start __prom_init_toc_end btext_setup_display TOC."
30
31 NM="$1"
32 OBJ="$2"
33
34 ERROR=0
35
36 function check_section()
37 {
38     file=$1
39     section=$2
40     size=$(objdump -h -j $section $file 2>/dev/null | awk "\$2 == \"$section\" {print \$3}")
41     size=${size:-0}
42     if [ $size -ne 0 ]; then
43         ERROR=1
44         echo "Error: Section $section not empty in prom_init.c" >&2
45     fi
46 }
47
48 for UNDEF in $($NM -u $OBJ | awk '{print $2}')
49 do
50         # On 64-bit nm gives us the function descriptors, which have
51         # a leading . on the name, so strip it off here.
52         UNDEF="${UNDEF#.}"
53
54         if [ $KBUILD_VERBOSE ]; then
55                 if [ $KBUILD_VERBOSE -ne 0 ]; then
56                         echo "Checking prom_init.o symbol '$UNDEF'"
57                 fi
58         fi
59
60         OK=0
61         for WHITE in $WHITELIST
62         do
63                 if [ "$UNDEF" = "$WHITE" ]; then
64                         OK=1
65                         break
66                 fi
67         done
68
69         # ignore register save/restore funcitons
70         case $UNDEF in
71         _restgpr_*|_restgpr0_*|_rest32gpr_*)
72                 OK=1
73                 ;;
74         _savegpr_*|_savegpr0_*|_save32gpr_*)
75                 OK=1
76                 ;;
77         esac
78
79         if [ $OK -eq 0 ]; then
80                 ERROR=1
81                 echo "Error: External symbol '$UNDEF' referenced" \
82                      "from prom_init.c" >&2
83         fi
84 done
85
86 check_section $OBJ .data
87 check_section $OBJ .bss
88 check_section $OBJ .init.data
89
90 exit $ERROR